/*
*	decs-smooth.h
*/


extern	double band_trace(SYMBAND A, int J, int M);
extern	double trace_prod(SYMBAND A, SYMBAND B, int M);
extern	void mult_band_vect(VECT y, SYMBAND A, VECT x, int J, int N);
extern	void mult_full_vect(VECT v, SYMBAND A, VECT z, int M);
extern	void mult_full_band(SYMBAND C, SYMBAND A, SYMBAND B, int M);
extern	void sym_band_to_mat(CMAT A, SYMBAND B, int J, int N);
extern	void mat_to_sym_band(SYMBAND B, CMAT A, int J, int N);

extern	double best_indiv(VECT ys, VECT trace, ALPHA_SET alpha, VECT ti,
	VECT yi, int l_score_id, double tol, int MM, int nn);

extern	double best_mse(CMAT l_ys, CMAT l_yr, ALPHA_SET alpha,
	VECT ti, CMAT yi, COVAR * covar,
	bool flag_iid, int M, int N, double tol);

extern	double best_score(CMAT ys, ALPHA_SET alpha,
	VECT ti, CMAT yi, COVAR *covar,
	bool flag_iid, int M, int N, int l_score_id, double tol, bool chat);

extern	COVAR *alloc_covar(int M, int N);

extern	void covar_free(COVAR *cov, int N);
extern	void copy_covar(COVAR *src, COVAR *dst, int MM);
extern	void scale_covar(COVAR *cov, double scale, int MM);
extern	COVAR *inv_to_covar_set(CMAT isigma, int M, int N, bool flag_iid);

extern	bool cv_setup_alloc(void);
extern	bool cv_setup_covar(void);
extern	void cv_cleanup(void);
extern	bool cross_val(double *ur, double *cv, double *gcv, int job);
extern	bool trace_i_a(double *trace, ALPHA_SET alpha);

extern	void select_nth_qbiqt(SYMBAND F, SYMBAND IB, SYMBAND Qt,
	int M, int N, int n);
extern	double rss_term(VECT err, SYMBAND inv, int M);
extern	double ur_term(SYMBAND Fn, SYMBAND cov2, int M);
extern	double cv_term(VECT err, SYMBAND FL, VECT FD, SYMBAND inv, int M);
extern	double gcv_term(SYMBAND Fn, SYMBAND cov, int M);

extern	bool vspline(CMAT ys, ALPHA_SET alpha, VECT ti, CMAT yi,
	CMAT isigma, bool flag_iid, int MM, int nn);

extern	bool vect_smooth(CMAT ys, double *ur, double *cv, double *gcv,
	double *penin, double *penout, double *rough, ALPHA_SET alpha,
	VECT ti, CMAT yi, COVAR *covar, bool flag_iid, int MM, int nn);

extern	bool cubic_interp(VECT ys, VECT ti, VECT yi, VECT xs, int nn, int nx);

extern	void kron_diag(SYMBAND K, SYMBAND B, int J, int N, VECT D, int M);
extern	bool chol_sym_band(BAND L, VECT D, SYMBAND B, int J, int N);
extern	void solve_sym_band(VECT x, BAND L, VECT D, VECT z,
	int J, int N, int job);
extern	void invert_sym_band(SYMBAND IB, SYMBAND L, VECT D, int J, int N);

extern	bool spline_mat(SYMBAND R, BAND Qt, VECT ti, int N);
extern	void form_qt_Y(VECT QtY, BAND Qt, VECT Y, int M, int N);
extern	void form_qt_s_q(SYMBAND QtSQ, BAND Qt, COVAR *covar,
	int M, int N, bool flag_iid);

extern	void form_band(SYMBAND sum, SYMBAND R_A, SYMBAND QtSQ, int M, int N);
extern	void form_q_c(VECT q_c, BAND Qt, VECT c, int M, int N);
extern	void form_sig_q_c(OMATRIX sig_q_c, COVAR *covar, CMAT q_c,
	int M, int N, bool flag_iid);

extern	bool vs_setup_alloc(int M, int N);
extern	bool vs_setup_ti(VECT ti, int N);
extern	bool vs_setup_yi(VECT yi, int M, int N);
extern	bool vs_setup_cov(COVAR *covar, bool flag_iid);
extern	void vs_cleanup(void);
extern	bool vs_setup_alpha(ALPHA_SET alpha);
extern	bool vs_smooth(CMAT result, int job);
extern	bool vs_transfer(void);
extern	double roughness(void);
extern	double post_penalty(void);
extern	bool penalty(double *pen, ALPHA_SET alpha, VECT yi, int M, int N);
